<?php
//////////////////////////////////////////////////////////////
//        IISS - Internet Information Service System        //
// Fejleszt: [VegaNetworkTeam] - http://www.veganetwork.tk //
//                           ---                            //
//               IISS - The future in CMS                   //
//////////////////////////////////////////////////////////////

if (!defined('SMARTY_DIR')) {
	exit();
}
/**
* Base class: Smarty template engine
*/
require_once SMARTY_DIR.'Smarty.class.php';

/**
* Template engine
*
* @package		kernel
* @subpackage	core
*
* @author		Kazumi Ono 	<onokazu@xoops.org>
* @copyright	(c) 2000-2003 The Xoops Project - www.xoops.org
*/
class XoopsTpl extends Smarty
{
	
	/**
	* Allow update of template files from the themes/ directory?
	* This should be set to false on an active site to increase performance
	*/
	var $_canUpdateFromFile = false;
	
	/**
	* Constructor
	**/
	function XoopsTpl()
	{
		global $xoopsConfig;
		$this->Smarty();
		$this->compile_id = null;
		if ($xoopsConfig['theme_fromfile'] == 1) {
			$this->_canUpdateFromFile = true;
			$this->compile_check = true;
		} else {
			$this->_canUpdateFromFile = false;
			$this->compile_check = false;
		}
		$this->left_delimiter =  '<{';
		$this->right_delimiter =  '}>';
		$this->template_dir = XOOPS_THEME_PATH;
		$this->cache_dir = XOOPS_CACHE_PATH;
		$this->compile_dir = XOOPS_COMPILE_PATH;
		$this->plugins_dir = array(XOOPS_ROOT_PATH.'/class/smarty/plugins');
		$this->default_template_handler_func = 'xoops_template_create';
		
		// Added by goghs on 11-26 to deal with safe mode
		//if (ini_get('safe_mode') == "1") {
		$this->use_sub_dirs = false;
		//} else {
		//	$this->use_sub_dirs = true;
		//}
		// END
		
		$this->assign(array('xoops_url' => XOOPS_URL, 'xoops_rootpath' => XOOPS_ROOT_PATH, 'xoops_langcode' => _LANGCODE, 'xoops_charset' => _CHARSET, 'xoops_version' => XOOPS_VERSION, 'xoops_upload_url' => XOOPS_UPLOAD_URL));
		
		// ML Hack by marcan. Thanks to King76 !
		global $_SERVER, $myts;
		$myts =& MyTextSanitizer::getInstance();
		
		$this->assign(array('xoopsml_version' => '1.4', 'lang_name' => $xoopsConfig['language']));
		
		// Add your custom smarty variables here. You will be able to use them in your theme
		$this->assign('welcome',$myts->makeTboxData4Show("[fr]Bienvenue[/fr][en]Welcome[/en]"));
		$this->assign('privacy',$myts->makeTboxData4Show("[fr]Politique de confidentialit[/fr][en]Privacy policy[/en]"));
		$this->assign('hello',$myts->makeTboxData4Show("[fr]Bonjour[/fr][en]Hello[/en]"));
		$this->assign('youraccount',$myts->makeTboxData4Show("[fr]Votre compte[/fr][en]Your Account[/en]"));
		$this->assign('readoursite',$myts->makeTboxData4Show("[fr]Read our site in[/fr][en]Voir notre site en[/en]"));
		$this->assign('search',$myts->makeTboxData4Show("[fr]recherche[/fr][en]search[/en]"));
		$this->assign('register',$myts->makeTboxData4Show("[fr]Devenez membre[/fr][en]Register now[/en]"));
		$this->assign('on',$myts->makeTboxData4Show("[fr]de[/fr][en]on[/en]"));
		$this->assign('sur',$myts->makeTboxData4Show("[fr]sur[/fr][en]on[/en]"));
		$this->assign('login',$myts->makeTboxData4Show("[fr]Connexion[/fr][en]Login[/en]"));
		$this->assign('developpedby',$myts->makeTboxData4Show("[fr]Dvelopp par[/fr][en]Developped by[/en]"));
		$this->assign('with',$myts->makeTboxData4Show("[fr]avec[/fr][en]with[/en]"));
		$this->assign('themeby',$myts->makeTboxData4Show("[fr]Thme par[/fr][en]Theme by[/en]"));
		$this->assign('rightsreserved',$myts->makeTboxData4Show("[fr]Tout droit rservs.[/fr][en]All rights reserved[/en]"));		
		$this->assign('multilanguages',$myts->makeTboxData4Show("[fr]Multilangues[/fr][en]Multilanguages[/en]"));		

		$this->assign('home_lower',$myts->makeTboxData4Show("[fr]accueil[/fr][en]home[/en]"));
		$this->assign('downloads_lower',$myts->makeTboxData4Show("[fr]tlchargements[/fr][en]downloads[/en]"));
		$this->assign('contactus_lower',$myts->makeTboxData4Show("[fr]Contactez-nous[/fr][en]Contact us[/en]"));
		$this->assign('home_upper',$myts->makeTboxData4Show("[fr]ACCUEIL[/fr][en]HOME[/en]"));
		$this->assign('downloads_upper',$myts->makeTboxData4Show("[fr]TLCHARGEMENTS[/fr][en]DOWNLOADS[/en]"));
		$this->assign('contactus_upper',$myts->makeTboxData4Show("[fr]CONTACTEZ-NOUS[/fr][en]CONTACT US[/en]"));
		// End of ML Hack
	}
	
	/**
	* Set the directory for templates
	*
	* @param   string  $dirname    Directory path without a trailing slash
	**/
	function xoops_setTemplateDir($dirname)
	{
		$this->template_dir = $dirname;
	}
	
	/**
	* Get the active template directory
	*
	* @return  string
	**/
	function xoops_getTemplateDir()
	{
		return $this->template_dir;
	}
	
	/**
	* Set debugging mode
	*
	* @param   boolean     $flag
	**/
	function xoops_setDebugging($flag=false)
	{
		$this->debugging = is_bool($flag) ? $flag : false;
	}
	
	/**
	* Set caching
	*
	* @param   integer     $num
	**/
	function xoops_setCaching($num=0)
	{
		$this->caching = (int)$num;
	}
	
	/**
	* Set cache lifetime
	*
	* @param   integer     $num    Cache lifetime
	**/
	function xoops_setCacheTime($num=0)
	{
		$num = (int)$num;
		if ($num <= 0) {
			$this->caching = 0;
		} else {
			$this->cache_lifetime = $num;
		}
	}
	
	/**
	* Set directory for compiled template files
	*
	* @param   string  $dirname    Full directory path without a trailing slash
	**/
	function xoops_setCompileDir($dirname)
	{
		$this->compile_dir = $dirname;
	}
	
	/**
	* Set the directory for cached template files
	*
	* @param   string  $dirname    Full directory path without a trailing slash
	**/
	function xoops_setCacheDir($dirname)
	{
		$this->cache_dir = $dirname;
	}
	
	/**
	* Render output from template data
	*
	* @param   string  $data
	* @return  string  Rendered output
	**/
	function xoops_fetchFromData(&$data)
	{
		$dummyfile = XOOPS_CACHE_PATH.'/dummy_'.time();
		$fp = fopen($dummyfile, 'w');
		fwrite($fp, $data);
		fclose($fp);
		$fetched = $this->fetch('file:'.$dummyfile);
		unlink($dummyfile);
		$this->clear_compiled_tpl('file:'.$dummyfile);
		return $fetched;
	}
	
	/**
	*
	**/
	function xoops_canUpdateFromFile()
	{
		return $this->_canUpdateFromFile;
	}
}

/**
* Smarty default template handler function
*
* @param $resource_type
* @param $resource_name
* @param $template_source
* @param $template_timestamp
* @param $smarty_obj
* @return  bool
**/
function xoops_template_create ($resource_type, $resource_name, &$template_source, &$template_timestamp, &$smarty_obj)
{
	if ( $resource_type == 'db' ) {
		$file_handler =& xoops_gethandler('tplfile');
		$tpl =& $file_handler->find('default', null, null, null, $resource_name, true);
		if (count($tpl) > 0 && is_object($tpl[0])) {
			$template_source = $tpl[0]->getSource();
			$template_timestamp = $tpl[0]->getLastModified();
			return true;
		}
	} else {
	}
	return false;
}

/**
* function to update compiled template file in templates_c folder
*
* @param   string  $tpl_id
* @param   boolean $clear_old
* @return  boolean
**/
function xoops_template_touch($tpl_id, $clear_old = true)
{
	$tpl = new XoopsTpl();
	$tpl->force_compile = true;
	$tplfile_handler =& xoops_gethandler('tplfile');
	$tplfile =& $tplfile_handler->get($tpl_id);
	if ( is_object($tplfile) ) {
		$file = $tplfile->getVar('tpl_file');
		if ($clear_old) {
			$tpl->clear_cache('db:'.$file);
			$tpl->clear_compiled_tpl('db:'.$file);
		}
		$tpl->fetch('db:'.$file);
		return true;
	}
	return false;
}

/**
* Clear the module cache
*
* @param   int $mid    Module ID
* @return
**/
function xoops_template_clear_module_cache($mid)
{
	$block_arr =& XoopsBlock::getByModule($mid);
	$count = count($block_arr);
	if ($count > 0) {
		$xoopsTpl = new XoopsTpl();
		$xoopsTpl->xoops_setCaching(2);
		for ($i = 0; $i < $count; $i++) {
			if ($block_arr[$i]->getVar('template') != '') {
				$xoopsTpl->clear_cache('db:'.$block_arr[$i]->getVar('template'));
			}
		}
	}
}
?>