<?php
include ('header.php');

$cfgBackupTarget = $xoopsModuleConfig['cfgBackupTarget'];
$drop = $xoopsModuleConfig['drop'];
$cfgZipType = $xoopsModuleConfig['cfgZipType'];
$cfgExecTimeLimit = $xoopsModuleConfig['cfgExecTimeLimit'];
$use_backquotes = $xoopsModuleConfig['use_backquotes'];

$server = XOOPS_DB_NAME;

require('include/defines.lib.php');
require('include/build_dump.lib.php');
require('include/zip.lib.php');

function PMA_myHandler($sql_insert)
{
    global $tmp_buffer;
    $eol_dlm = (isset($GLOBALS['extended_ins']) && ($GLOBALS['current_row'] < $GLOBALS['rows_cnt']))
             ? ','
             : ';';
    $tmp_buffer .= $sql_insert . $eol_dlm . $GLOBALS['crlf'];
}

function PMA_whichCrlf()
{
    $the_crlf = "\n";
    if (PMA_USR_OS == 'Win') {
        $the_crlf = "\r\n";
    }
    else if (PMA_USR_OS == 'Mac') {
        $the_crlf = "\r";
    }
    else {
        $the_crlf = "\n";
    }
    return $the_crlf;
}

$err_url = XOOPS_URL;

@set_time_limit($cfgExecTimeLimit);
$dump_buffer = '';
$crlf        = PMA_whichCrlf();

$filename = 'bkp'.date('ymdHi');
if (($cfgZipType == 'bzip') && (PMA_PHP_INT_VERSION >= 40004 && @function_exists('bzcompress'))) {
    $ext       = 'bz2';
    $mime_type = 'application/x-bzip';
} else if (($cfgZipType == 'gzip') &&(PMA_PHP_INT_VERSION >= 40004 && @function_exists('gzencode'))) {
    $ext       = 'gz';
    $mime_type = 'application/x-gzip';
} else if (($cfgZipType == 'zip') && (PMA_PHP_INT_VERSION >= 40000 && @function_exists('gzcompress'))) {
    $ext       = 'zip';
    $mime_type = 'application/x-zip';
} else {
    $ext       = 'sql';
	$cfgZipType = 'none';
    $mime_type = (PMA_USR_BROWSER_AGENT == 'IE' || PMA_USR_BROWSER_AGENT == 'OPERA')
               ? 'application/octetstream'
               : 'application/octet-stream';
}

$tables     = mysql_list_tables($db = XOOPS_DB_NAME);
$num_tables = @mysql_numrows($tables);

if ($num_tables == 0) {
    echo '# ' ._DB_NOTABLESFOUND;
}
else {
    $dump_buffer       .= '# Backup for MySQL' . $crlf
                       .  '#' . $crlf;
    $formatted_db_name = (isset($use_backquotes))
                       ? PMA_backquote($db)
                       : '\'' . $db . '\'';
    $i = 0;
    while ($i < $num_tables) {
        $table = mysql_tablename($tables, $i);
        $formatted_table_name = (isset($use_backquotes))
                              ? PMA_backquote($table)
                              : '\'' . $table . '\'';
        $dump_buffer .= '# --------------------------------------------------------' . $crlf
                     .  $crlf . '#' . $crlf
                     .  '# ' ._DB_TABLESTRUCTURE. ' ' . $formatted_table_name . $crlf
                     .  '#' . $crlf . $crlf
                     .  PMA_getTableDef($db, $table, $crlf, $err_url) . ';' . $crlf;

        $tcmt = $crlf . '#' . $crlf
                     .  '# ' ._DB_DUMPINGDATA. ' ' . $formatted_table_name . $crlf
                     .  '#' . $crlf .$crlf;
        $dump_buffer .= $tcmt;
        $tmp_buffer  = '';
        if (!isset($limit_from) || !isset($limit_to)) {
            $limit_from = $limit_to = 0;
        }
        PMA_getTableContent($db, $table, $limit_from, $limit_to, 'PMA_myHandler', $err_url);
        $dump_buffer .= $tmp_buffer;
        $i++;
    }
    $dump_buffer .= $crlf;
}

if ($cfgZipType == 'zip') {
    if (PMA_PHP_INT_VERSION >= 40000 && @function_exists('gzcompress')) {
        $extbis = '.sql';
        $zipfile = new zipfile();
        $zipfile -> addFile($dump_buffer, $filename . $extbis);
        $dump_buffer = $zipfile -> file();
    }
}
else if ($cfgZipType == 'bzip') {
    if (PMA_PHP_INT_VERSION >= 40004 && @function_exists('bzcompress')) {
        $dump_buffer = bzcompress($dump_buffer);
    }
}
else if ($cfgZipType == 'gzip') {
    if (PMA_PHP_INT_VERSION >= 40004 && @function_exists('gzencode')) {
        // without the optional parameter level because it bug
        $dump_buffer = gzencode($dump_buffer);
    }
}

$fp = fopen(XOOPS_ROOT_PATH.'/modules/backup/cache/'. $filename . '.' . $ext,'w');
fwrite($fp, $dump_buffer);
fclose($fp);
if (isset($HTTP_POST_VARS['oldurl'])) {
   $oldurl = $HTTP_POST_VARS['oldurl'];
}
$oldurl = (!isset($oldurl)||empty($oldurl)) ? XOOPS_URL : $oldurl;
if ($cfgBackupTarget == 'download') {
	header('Content-Type: ' . $mime_type);
    if (PMA_USR_BROWSER_AGENT == 'IE') {
        header('Content-Disposition: inline; filename="' . $filename . '.' . $ext . '"');
        header('Expires: 0');
        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
        header('Pragma: public');
    } else {
        header('Content-Disposition: attachment; filename="' . $filename . '.' . $ext . '"');
        header('Expires: 0');
        header('Pragma: no-cache');
    }
    echo $dump_buffer;
} elseif ($cfgBackupTarget == 'email') {
    $subject = 'Backup from '.$xoopsConfig['sitename'].'. Create on '.date('H:i D d-M-Y').'.' ;    
    $message  = "Download the backup by clicking here:\n";
    $message .= "".$xoopsConfig['xoops_url']."/modules/backup/cache/".$filename.'.'.$ext."\n\n";
    $message .= "----------------\n";
    $message .= $xoopsConfig['sitename']."\n".$xoopsConfig['xoops_url']."/";
    $xoopsMailer =& getMailer();
    $xoopsMailer->useMail();
    $xoopsMailer->setToEmails($xoopsConfig['adminmail']);
    $xoopsMailer->setFromEmail($xoopsConfig['adminmail']);
    $xoopsMailer->setFromName($xoopsConfig['sitename']);
    $xoopsMailer->setSubject($subject);
    $xoopsMailer->setBody($message);
    $xoopsMailer->send();
    redirect_header($oldurl,3,'Backup action: '.$cfgBackupTarget.' ready.' );
} else {
    redirect_header($oldurl,3,'Backup action: '.$cfgBackupTarget.' ready.' );
}
?>