<?
require('header.php');

$myts    =& MyTextSanitizer::getInstance();
$dirname = $xoopsModule->dirname();


if (isset($_POST['action'])) 
	$action = $_POST['action'];
else if (isset($_GET['action']))
	$action = $_GET['action'];
else
	$action = '';

//determine proper smarty template for page
switch($action) {
	case 'subscribe_conf':
	case 'unsubscribe_conf':
		$xoopsOption['template_main'] = 'evennews_notice.html';
		break;
	case 'subscribe':
		$xoopsOption['template_main'] = 'evennews_subscr.html';
		break;
	case 'unsubscribe':
		$xoopsOption['template_main'] = 'evennews_unsub.html';
		break;
	default:
		$xoopsOption['template_main'] = 'evennews_index.html';
		break;	
}

include(XOOPS_ROOT_PATH.'/header.php');	// Include the page header 

//Fill smarty variables for each page
switch($action) {
	case 'subscribe_conf':
		if ($_POST['user_mail'] == '') {
			$xoopsTpl->assign('en_message', _EN_GENERROR);
			break;
		}
				
		$ret = addUser(); // Try to add user
		//Display Appropriate Response to addUser Return value
		switch($ret) {
			case 1:		//User Added, Confirmation Sent
				$xoopsTpl->assign('en_message', sprintf(_EN_CONFIRM, $_POST['user_mail']));
				break;
			case 2: 	//Resending confirmation
				$xoopsTpl->assign('en_message', sprintf(_EN_RESENDCONFIRM, $_POST['user_mail']));
				break;
			case -1:	//Email Already Exists
				$xoopsTpl->assign('en_message', _EN_EMAILEXISTS);
				break;
			case -2:  //Unable to send mail
				$xoopsTpl->assign('en_message', _EN_EMAILERROR);
				break;
		}
		break;
		
	case 'unsubscribe_conf':
		if ($_POST['user_mail'] == '') {
			$xoopsTpl->assign('en_message', _EN_GENERROR);
			break;
		}
		$ret = delUser();  // Try to del user
		
		switch($ret) {
			case 1:		//User Removed
				$xoopsTpl->assign('en_message', sprintf(_EN_REMOVED, $_POST['user_mail']));
				break;
			case 0:   //User Unsubscribed, or unconfirmed
				$xoopsTpl->assign('en_message', _EN_REMERROR);
				break;
		}
		break;
	case 'subscribe':
		$xoopsTpl->assign('en_title', sprintf(_EN_SUBCTITLE, $xoopsConfig['sitename']));
		$xoopsTpl->assign('en_form_action', XOOPS_URL . '/modules/' . $dirname . '/index.php');
		$xoopsTpl->assign('EN_DISCLAIMER', sprintf(_EN_DISCLAIMER, $xoopsConfig['sitename'], $xoopsConfig['sitename']));
		$xoopsTpl->assign('en_remote_host', $_SERVER['REMOTE_HOST']);
		
		if ($xoopsUser) {
			$xoopsTpl->assign('en_realname', $xoopsUser->getVar('name'));
			$xoopsTpl->assign('en_username', $xoopsUser->getVar('uname'));
			$xoopsTpl->assign('en_email', $xoopsUser->getVar('email'));
		} else {
			$xoopsTpl->assign('en_realname', '[enter your real name]');
			$xoopsTpl->assign('en_username', '[enter your user name]');
			$xoopsTpl->assign('en_email', '[enter your email address]');
		}
		
		
		break;
	case 'unsubscribe':
		$xoopsTpl->assign('en_title', sprintf(_EN_UNSUBTITLE, $xoopsConfig['sitename']));
		$xoopsTpl->assign('en_form_action', XOOPS_URL .'/modules/'.$dirname.'/index.php');
		if ($xoopsUser) {
			$xoopsTpl->assign('en_email', $xoopsUser->getVar('email'));
		} else {
			$xoopsTpl->assign('en_email', '[enter your email address]');
		}
		break;
	default:
		$xoopsTpl->assign('subscr_url', $PHP_SELF . '?action=subscribe');
		$xoopsTpl->assign('unsubscr_url', $PHP_SELF . '?action=unsubscribe');
		$xoopsTpl->assign('news_images', sprintf('%s/modules/%s/images/', XOOPS_URL, $dirname));
		break;
}
// Include the page footer
include(XOOPS_ROOT_PATH.'/footer.php');

/* ------------------------------------------------------------
function delUser() - Removes a user from the newsletter by marking
them unconfirmed.
-------------------------------------------------------------*/
function delUser()
{
	global $xoopsDB, $myts, $xoopsConfig, $xoopsModule;
		
	$query = "SELECT * FROM ". $xoopsDB->prefix('evennews_members') ." WHERE user_email='" . $myts->makeTboxData4Save($_POST['user_mail']) . "' ";
	$result = $xoopsDB->query($query);
	$myarray = $xoopsDB->fetchArray($result);
		
	$mymail = $myts->makeTboxData4Save($_POST['user_mail']);
	if ($myarray) {
		if ($myarray['confirmed'] == '0')
			return -1;
			
		$query = "UPDATE " . $xoopsDB->prefix('evennews_members') . " SET confirmed='0' WHERE user_email='$mymail'";
		$result = $xoopsDB->queryF($query);
		return 1;
	} else {
		return -2;
	}
}

/* ------------------------------------------------------------
function addUser() - Adds a user to db and sends confirm email
-------------------------------------------------------------*/
function addUser()
{
	global $xoopsDB, $myts, $xoopsConfig, $xoopsModule;
	
	$user_name = $myts->makeTboxData4Save($_POST['user_name']);
	$user_nick = $myts->makeTboxData4Save($_POST['user_nick']);
	$user_mail = $myts->makeTboxData4Save($_POST['user_mail']);
	$user_host = $myts->makeTboxData4Save($_SERVER['REMOTE_HOST']);
	$query     = "SELECT * FROM ". $xoopsDB->prefix('evennews_members')." WHERE user_email='$user_mail' ";
	$myarray   = $xoopsDB->fetchArray($xoopsDB->query($query));
	
	$xoopsMailer =& getMailer();
	$xoopsMailer->useMail();
	
	if (!$myarray) {	// New User
		$better_token = md5(uniqid(rand(), 1));
		$query = "INSERT INTO " . $xoopsDB->prefix('evennews_members') . " (user_id, user_name, user_nick, user_email, user_host, user_conf, user_time) ";
		$query .= "VALUES (0, '$user_name', '$user_nick', '$user_mail', '$user_host', '$better_token', NOW())";
		$result = $xoopsDB->queryF($query);
	
		$confirm_url = XOOPS_URL .'/modules/'.$xoopsModule->dirname().'/confirm.php?id='.$better_token;
		$xoopsMailer->setToEmails($_POST['user_mail']);
		$xoopsMailer->setFromEmail($xoopsConfig['adminmail']);
		$xoopsMailer->setFromName($xoopsConfig['sitename']);
		$xoopsMailer->setSubject(_EN_CONFIRM_SUBJECT);
		$xoopsMailer->setBody(sprintf(_EN_CONFIRM_EMAIL, $xoopsConfig['adminmail'], $confirm_url));
		
		if ($xoopsMailer->send()) {
			return 1;
		} else {
			return -2;
		}
		
	} elseif ($myarray['confirmed'] == '0') {	//Still Needs Confirmation
		$confirm_url = XOOPS_URL .'/modules/'.$xoopsModule->dirname().'/confirm.php?id='.$myarray[user_conf];
		$xoopsMailer->setToEmails($myarray['user_email']);
		$xoopsMailer->setFromEmail($xoopsConfig['adminmail']);
		$xoopsMailer->setFromName($xoopsConfig['sitename']);
		$xoopsMailer->setSubject(_EN_CONFIRM_SUBJECT);
		$xoopsMailer->setBody(sprintf(_EN_CONFIRM_EMAIL, $xoopsConfig['adminmail'], $confirm_url));
		
		if ($xoopsMailer->send()) {
			return 2;
		} else {
			return -2;
		} 
	} else {  // Duplicate Email in db
		return  -1;
	}
}
?>