<?php
/***************************************************************************
 * Xoops i-stats module
 *
 * Ported to xoops 2 by sylvainb
 * http://123rando.com
 *
 * Version 1.00
 *
 ***************************************************************************
 *
 * E-Xoops i-Stats module
 *
 * Scripters i-Stats module
 * Version 1.02
 *
 * author Paul Cooke <paul_sw19@yahoo.com>
 * http://paul-cooke.com
 *
 * copyright
 * Copyright (c) 2003 Paul Cooke <paul_sw19@yahoo.com>
 *
 * license
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

/**
 * @description
 * As of version 1.02 there is a block for displaying stats.
 *
 * @feature
 * Block for showing stats.
 *
 * @changelog
 * v1.02 Added block for displaying stats
 * @faq
 *
 * Q. How do I change the contents of the block?
 * A. Comment out the lines in 'blocks/istats_blocks.php' that you dont want to display.
 *
 */
function b_istats_show() {
	global $xoopsConfig;

 	if ( @file_exists(XOOPS_ROOT_PATH . '/modules/istats/language/'.$xoopsConfig['language'].'/main.php') ) {
 		include_once(XOOPS_ROOT_PATH . '/modules/istats/language/'.$xoopsConfig['language'].'/main.php');
 	} else {
 		include_once(XOOPS_ROOT_PATH . '/modules/istats/language/english/main.php');
 	}

	include_once(XOOPS_ROOT_PATH . '/modules/istats/include/function.php');
	$results = CountDays();

	$block['title'] =  _MI_ISTATS_NAME;

	$content  = '<table cellspacing="1">';
	$content .= '<tr><td style="font-size: xx-small;">' . _AM_P_PAGE .        ':</td><td style="font-size: xx-small;">' . $results['totalpages'] .    '</td></tr>';	// The total number of pages served
	$content .= '<tr><td style="font-size: xx-small;">' . _AM_TOTAL_VISITS .  ':</td><td style="font-size: xx-small;">' . $results['total'] .         '</td></tr>';	// The total number of visitors
	$content .= '<tr><td style="font-size: xx-small;">' . _AM_TOTAL_DAYS .    ':</td><td style="font-size: xx-small;">' . $results['days'] .          '</td></tr>';	// The number of days that stats are available for
	$content .= '<tr><td style="font-size: xx-small;">' . _AM_AVE_DAY .       ':</td><td style="font-size: xx-small;">' . sprintf ("%.2f", $results['ava_day']) .  '</td></tr>';	// The average number of visitors per day
	$content .= '<tr><td style="font-size: xx-small;">' . _AM_AVE_HOUR .      ':</td><td style="font-size: xx-small;">' . sprintf ("%.2f", $results['ava_hour']) . '</td></tr>';	// The average number of visitors per hour
	$content .= '<tr><td style="font-size: xx-small;">' . _AM_AVE_WEEK .      ':</td><td style="font-size: xx-small;">' . sprintf ("%.2f", $results['ava_week']) . '</td></tr>';	// The average number of visitors per week
	$content .= '<tr><td style="font-size: xx-small;">' . _AM_AVE_MTH .       ':</td><td style="font-size: xx-small;">' . sprintf ("%.2f", $results['ava_mth']) .  '</td></tr>';	// The average number of visitors per month
	$content .= '<tr><td style="font-size: xx-small;">' . _AM_MAX_DATE .      ':</td><td style="font-size: xx-small;">' . $results['max_date'] .      '</td></tr>';	// The busiest day
	$content .= '<tr><td style="font-size: xx-small;">' . _AM_MAX_DAYCOUNT .  ':</td><td style="font-size: xx-small;">' . $results['max_daycount'] .  '</td></tr>';	// The number of visits on the busiest day
	$content .= '<tr><td style="font-size: xx-small;">' . _AM_TODAY .         ':</td><td style="font-size: xx-small;">' . $results['today'] .         '</td></tr>';	// The number of visitors so far today
	$content .= '<tr><td style="font-size: xx-small;">' . _AM_THIS_WEEK .     ':</td><td style="font-size: xx-small;">' . $results['this_week'] .     '</td></tr>';	// The number of visitors so far this week
	$content .= '<tr><td style="font-size: xx-small;">' . _AM_THIS_MTH .      ':</td><td style="font-size: xx-small;">' . $results['this_mth'] .      '</td></tr>';	// The number of visitors so far this month
	$content .= '<tr><td style="font-size: xx-small;">' . _AM_MAX_WEEK .      ':</td><td style="font-size: xx-small;">' . $results['max_week'] .      '</td></tr>';	// The busiest week, as year # week number '2003 # 47'
	$content .= '<tr><td style="font-size: xx-small;">' . _AM_MAX_WEEKCOUNT . ':</td><td style="font-size: xx-small;">' . $results['max_weekcount'] . '</td></tr>';	// The number of visitors in the busiest week
	$content .= '<tr><td style="font-size: xx-small;">' . _AM_MAX_MTH .       ':</td><td style="font-size: xx-small;">' . $results['max_mth'] .       '</td></tr>';	// The busiest month
	$content .= '<tr><td style="font-size: xx-small;">' . _AM_MAX_MTHCOUNT .  ':</td><td style="font-size: xx-small;">' . $results['max_mthcount'] .  '</td></tr>';	// The number of visitors in the busiest month
	$content .= '</table>';

	$block['content'] = $content;
	return $block;
}

?>
