<?php
/***************************************************************************
 * Xoops i-stats module
 *
 * Ported to xoops 2 by sylvainb
 * http://123rando.com
 *
 * Version 1.00
 *
 ***************************************************************************
 *
 * @brief
 * E-Xoops i-Stats module.
 *
 * @desc
 * Records anonymous data as supplied by the users browser (via javascript).
 *
 * It displays details of the usual stats plus:<ul>
 * <li> the pages served</li>
 * <li> users browser</li>
 * <li> users OS</li>
 * <li> users screen size</li>
 * <li> users colour depth</li>
 * <li> lists (with count) referers</li>
 * <li> etc.</li>
 * </ul>
 *
 * As of version 1.01 i-Stats can be used as a graphical counter.
 *
 * @version
 * Version 1.03
 *
 * @author
 * Paul Cooke <paul_sw19@yahoo.com>
 * <a href="http://?">http://paul-cooke.com</a>
 *
 * @copyright
 * Copyright (c) 2003 Paul Cooke <paul_sw19@yahoo.com>
 *
 * @license
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
/**
 * @note
 * This module is based on:
 * PHP i-Stats Version 1.5
 * Developed By Sam Tang (sam@hkscript.com)
 * License : GNU Public License (GPL)
 * Homepage : http://hkscript.com
 *
 * @faq
 * Q. Why did you choose to use i-Stats
 * A. For several reasons,
 * * It was written in English, making it easy for me to understand,
 * * It is well written, both syntactically and logically,
 * * Uses database accesses economically,
 * * Is designed in a way that does not get bogged down with historical data.
 */
/**
 * @changelog
 * v1.02 Fixed problem with truncated referer URL's (change to Installation).
 * v1.03 Hopefully corrected problem with path names in v1.02 zip file.
/**
 * @install
 * Upload all files to a directory called exoops/modules/istats on your server.
 *
 * Run E-Xoops admin, and install 'Web Stats' module.
 *
 * Give access to groups as required.
 *
 * Add the following code to the footer (Admin, Meta Generator, Footer Settings)
 * [ still effective even if theme changed  ;-) ]
 * <code>
 * &lt;!-- Add to footer --&gt;
 * &lt;script type="text/Javascript"&gt;
 * &lt;!--
 *	istat = new Image(1,1);
 *  istat.src = "http://yourdomian.com/exoops/modules/istats/counter.php?sw="+screen.width+"&sc="+screen.colorDepth+"&refer="+escape(document.referrer)+"&page="+location.href;
 * // --&gt;
 * &lt;/script&gt;
 * &lt;!-- end --&gt;
 * </code>
 *
 * Do not put a line break in the istat.src line!!
 *
 * And don't forget to change 'yourdomain.com' to your sites domain.
 *
 * @upgrade
 * v1.02 to v1.03
 * Upload the files to your server.
 */

include('header.php');

if ($xoopsConfig['startpage'] == "istats") {
	$xoopsOption['show_rblock'] = 1;
	include_once(XOOPS_ROOT_PATH."/header.php");
	make_cblock();
	} else {
		$xoopsOption['show_rblock'] = 0;
		include_once(XOOPS_ROOT_PATH."/header.php");
	}

include_once('include/function.php');

//OpenTable();
?>
<center>
<table width="100%" border="0" align="center" class="statstable">
  <tr class='head'>
    <td width="63" valign="top"><img src="images/logo.gif" border="0"></td>
    <td width="657" valign="top">
      <div align="center"><font size="3">
      <b><?= _AM_TRAFFIC_REPORT ?></b></font><br><br>
      <table width="657" border="0" align="center">
        <form>
        <tr>
          <td>
            <div align="center" class="statsdiv">
[ <a href="<?=$PHP_SELF ?>?action=1"><?= _AM_SUMMARY ?></a> ] &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; | &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
[ <a href="<?=$PHP_SELF ?>?action=2"><?= _AM_TRAFFIC ?></a> ] &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; | &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
[ <a href="<?=$PHP_SELF ?>?action=3"><?= _AM_VISITOR_INFO ?></a> ] &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; | &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
[ <a href="<?=$PHP_SELF ?>?action=4"><?= _AM_REFERER ?></a> ]
            </div>
          </td>
        </tr></form>
      </table>
      </div>
    </td>
  </tr>
</table>
</center>
<div align="center" class="statsdiv"><br>

<?


 switch($HTTP_GET_VARS['action']) {

	 case 4:
		 include "include/referer.php";
	     break;

	 case 3:
		 include "include/user_info.php";
	     break;

	 case 2:
		 include "include/stats.php";
	     break;

	 case 1:
	 default:
		 include "include/summary.php";
		 break;
}
?>

  <br><br>
  <hr>
  <br>
Original i-Stats script module : <a href="http://paul-cooke.com" target="_blank">Scripter</a><br />
Xoops 2 adaptation : <a href="http://123rando.com" target="_blank">sylvainb</a>
</div>
<?
//CloseTable();
include_once(XOOPS_ROOT_PATH."/footer.php");
?>
