<?php

// for older files
function myheader()
{
	global $mod_url ;

	$tpl = new XoopsTpl() ;
	$tpl->assign( array( 'mod_url' => $mod_url ) ) ;
	$tpl->display( 'db:myalbum_header.html' ) ;
}


// for older files
function myfooter()
{
	global $mod_copyright ;

	$tpl = new XoopsTpl() ;
	$tpl->assign( array( 'mod_copyright' => $mod_copyright ) ) ;
	$tpl->display( 'db:myalbum_footer.html' ) ;
}


// returns appropriate name from uid
function get_name_from_uid( $uid )
{
	global $myalbum_nameoruname ;

	if( $uid > 0 ) {
		$poster = new XoopsUser( $uid ) ;
		if( $myalbum_nameoruname == 'uname' ) {
			$name = $poster->uname() ;
		} else {
			$name = trim( $poster->name() ) ;
			if( $name == "" ) $name = $poster->uname() ;
		}
	} else {
		$name = _ALBM_CAPTION_GUESTNAME ;
	}

	return $name ;
}


// Get photo's array to assign into template
function get_array_for_photo_assign( $fetched_result_array )
{
	global $my_uid , $isadmin , $global_perms , $myts ;
	global $photos_url , $thumbs_url , $thumbs_dir ;
	global $myalbum_makethumb , $myalbum_thumbsize , $myalbum_popular , $myalbum_newdays ;

	extract( $fetched_result_array ) ;

	// Thumb image
	$width_spec = "width='$myalbum_thumbsize'" ;
	if( $myalbum_makethumb ) {
		list( $width , $height , $type ) = getimagesize( "$thumbs_dir/$lid.$ext" ) ;
		if( $width <= $myalbum_thumbsize ) 
		// if thumb images was made, 'width' and 'height' will not set.
		$width_spec = '' ;
	}

	// Voting stats
	if( $rating > 0 ) {
		if( $votes == 1 ) {
			$votestring = _ALBM_ONEVOTE ;
		} else {
			$votestring = sprintf( _ALBM_NUMVOTES , $votes ) ;
		}
		$info_votes = "<b>"._ALBM_RATINGC."</b>".number_format( $rating , 2 )." ($votestring)";
	} else {
		$info_votes = '' ;
	}

	// Submitter's name
	$submitter_name = get_name_from_uid( $submitter ) ;

	return array(
		'lid' => $lid ,
		'cid' => $cid ,
		'ext' => $ext ,
		'res_x' => $res_x ,
		'res_y' => $res_y ,
		'window_x' => $res_x + 16 ,
		'window_y' => $res_y + 16 ,
		'title' => $myts->makeTboxData4Show( $title ) ,
		'datetime' => formatTimestamp( $date , 'm' ) ,
		'description' => $myts->makeTareaData4Show( $description , 0 ) ,
		'imgsrc_thumb' => "$thumbs_url/$lid.$ext" ,
		'imgsrc_photo' => "$photos_url/$lid.$ext" ,
		'width_spec' => $width_spec ,
		'can_edit' => ( ( $global_perms & GPERM_EDITABLE ) && ( $my_uid == $submitter || $isadmin ) ) ,
		'submitter' => $submitter ,
		'submitter_name' => $submitter_name ,
		'hits' => $hits ,
		'rating' => $rating ,
		'votes' => $votes ,
		'info_votes' => $info_votes ,
		'comments' => $comments ,
		'is_newphoto' => ( $date > time() - 86400 * $myalbum_newdays && $status == 1 ) , 
		'is_updatedphoto' => ( $date > time() - 86400 * $myalbum_newdays && $status == 2 ) , 
		'is_popularphoto' => ( $hits >= $myalbum_popular ) ,
		'info_morephotos' => sprintf( _ALBM_MOREPHOTOS . "</a>" , $submitter_name )
	) ;
}


// get list of sub categories in header space
function get_sub_categories( $parent_id , $cattree )
{
	global $xoopsDB , $myts , $table_cat ;

	$ret = array() ;

	$crs = $xoopsDB->query( "SELECT cid, title, imgurl FROM $table_cat WHERE pid=$parent_id ORDER BY title") or die( "Error: Get Category." ) ;

	while( list( $cid , $title , $imgurl ) = $xoopsDB->fetchRow( $crs ) ) {

		// Show first child of this category
		$subcat = array() ;
		$arr = $cattree->getFirstChild( $cid , "title" ) ;
		foreach( $arr as $child ) {
			$subcat[] = array(
				'cid' => $child['cid'] ,
				'title' => $myts->makeTboxData4Show( $child['title'] ) ,
				'photo_small_sum' => get_photo_small_sum_from_cat( $child['cid'] , "status>0" )
			) ;
		}

		// Category's banner default
		if( $imgurl == "http://" ) $imgurl = '' ;

		// Total sum of photos
		$cids = $cattree->getAllChildId( $cid ) ;
		array_push( $cids , $cid ) ;
		$photo_total_sum = get_photo_total_sum_from_cats( $cids , "status>0" ) ;

		$ret[] = array(
			'cid' => $cid ,
			'imgurl' => $myts->makeTboxData4Edit( $imgurl ) ,
			'photo_small_sum' => get_photo_small_sum_from_cat( $cid , "status>0" ) ,
			'photo_total_sum' => $photo_total_sum ,
			'title' => $myts->makeTboxData4Show( $title ) ,
			'subcategories' => $subcat
		) ;
	}

	return $ret ;
}

?>