<?php
// ------------------------------------------------------------------------- //
//                      myAlbum-P - XOOPS photo album                        //
//                        <http://www.peak.ne.jp/>                           //
// ------------------------------------------------------------------------- //

include( "header.php" ) ;
include_once( XOOPS_ROOT_PATH."/class/xoopstree.php" ) ;
include_once( XOOPS_ROOT_PATH."/class/uploader.php" ) ;

$myts =& MyTextSanitizer::getInstance() ;
$cattree = new XoopsTree( $table_cat , "cid" , "pid" ) ;


// check INSERTABLE
if( ! ( $global_perms & GPERM_INSERTABLE ) ) {
	redirect_header( XOOPS_URL."/user.php" , 2 , _ALBM_MUSTREGFIRST ) ;
	exit ;
}

// check Categories exist
$result = $xoopsDB->query( "SELECT count(cid) as count FROM $table_cat" ) ;
list( $count ) = $xoopsDB->fetchRow( $result ) ;
if( $count < 1 ) {
	redirect_header( XOOPS_URL."/modules/myalbum" , 2 , _ALBM_MUSTADDCATFIRST ) ;
	exit ;
}

// check file_uploads = on
if( ! ini_get( "file_uploads" ) ) {
	redirect_header(XOOPS_URL."/modules/myalbum",5,"PHP directive 'file_uploads' has to be turned on");
	exit ;
}

// get flag of safe_mode
$safe_mode_flag = ini_get( "safe_mode" ) ;

// check or make photos_dir
if( ! is_dir( $photos_dir ) ) {
	if( $safe_mode_flag ) {
		redirect_header(XOOPS_URL."/modules/myalbum",10,"At first create & chmod 777 '$photos_dir' by ftp or shell.");
		exit ;
	}

	$rs = mkdir( $photos_dir , 0777 ) ;
	if( ! $rs ) {
		redirect_header(XOOPS_URL."/modules/myalbum",10,"$photos_dir is not a directory");
		exit ;
	} else @chmod( $photos_dir , 0777 ) ;
}

// check or make thumbs_dir
if( $myalbum_makethumb && ! is_dir( $thumbs_dir ) ) {
	if( $safe_mode_flag ) {
		redirect_header(XOOPS_URL."/modules/myalbum",10,"At first create & chmod 777 '$thumbs_dir' by ftp or shell.");
		exit ;
	}

	$rs = mkdir( $thumbs_dir , 0777 ) ;
	if( ! $rs ) {
		redirect_header(XOOPS_URL."/modules/myalbum",10,"$thumbs_dir is not a directory");
		exit ;
	} else @chmod( $thumbs_dir , 0777 ) ;
}

// check or set permissions of photos_dir
if( ! is_writable( $photos_dir ) || ! is_readable( $photos_dir ) ) {
	$rs = chmod( $photos_dir , 0777 ) ;
	if( ! $rs ) {
		redirect_header(XOOPS_URL."/modules/myalbum",5,"chmod 0777 into $photos_dir failed");
		exit ;
	}
}

// check or set permissions of thumbs_dir
if( $myalbum_makethumb && ! is_writable( $thumbs_dir ) ) {
	$rs = chmod( $thumbs_dir , 0777 ) ;
	if( ! $rs ) {
		redirect_header(XOOPS_URL."/modules/myalbum",5,"chmod 0777 into $thumbs_dir failed");
		exit ;
	}
}



if( isset( $_POST['submit'] ) && $_POST['submit'] != "" ) {

	$submitter = $my_uid ;

	// Check if Title exist
	if( $_POST["title"] == "" ) {
		$_POST['title'] = 'no title' ;
	}

	$cid = isset( $_POST['cid'] ) ? $_POST['cid'] : 0 ;
	$newid = $xoopsDB->genId( $table_photos."_lid_seq" ) ;

	// Check if upload file name specified
	$field = $_POST["xoops_upload_file"][0] ;
	if( empty( $field ) || $field == "" ) {
		die( "UPLOAD error: file name not specified" ) ;
	}
	$field = $_POST['xoops_upload_file'][0] ;

	// Check if file uploaded
	if( $_FILES[$field]['tmp_name'] == "" || ! is_readable( $_FILES[$field]['tmp_name'] ) ) {
		redirect_header( 'submit.php' , 2 , _ALBM_FILEERROR ) ;
		exit ;
	}

	if( $myalbum_canresize ) $uploader = new XoopsMediaUploader( $photos_dir , $array_allowed_mimetypes , $myalbum_fsize ) ;
	else $uploader = new XoopsMediaUploader( $photos_dir , $array_allowed_mimetypes , $myalbum_fsize , $myalbum_width , $myalbum_height ) ;

	$uploader->setPrefix( 'tmp_' ) ;
	if( $uploader->fetchMedia( $field ) && $uploader->upload() ) {

		$title = $myts->makeTboxData4Save( $_POST["title"] ) ;
		$desc_text = $myts->makeTareaData4Save( $_POST["desc_text"] ) ;
		$date = time() ;
		$tmp_name = $uploader->getSavedFileName() ;
		$ext = preg_replace( "/^.+\.([^.]+)$/sU" , "\\1" , $tmp_name ) ;
		$status = ( $global_perms & GPERM_SUPERINSERT ) ? 1 : 0 ;

		$sql = "INSERT INTO $table_photos (lid, cid, title, ext, submitter, status, date, hits, rating, votes, comments) VALUES ($newid, $cid, '$title', '$ext', $submitter, $status, $date, 0, 0, 0, 0)";
		$xoopsDB->query( $sql ) or die( "DB error: INSERT photo table" ) ;
		if( $newid == 0 ) {
			$newid = $xoopsDB->getInsertId();
		}

		modifyPhoto( "$photos_dir/$tmp_name" , "$photos_dir/$newid.$ext" ) ;
		$dim = GetImageSize( "$photos_dir/$newid.$ext" ) ;
		$xoopsDB->query( "UPDATE $table_photos SET res_x={$dim[0]}, res_y={$dim[1]} WHERE lid=$newid") or die( "DB error: UPDATE photo table" ) ;

		if( ! createThumb( "$photos_dir/$newid.$ext" , $newid , $ext ) ) {
			$xoopsDB->query( "DELETE FROM $table_photos WHERE lid=$newid" ) ;
			redirect_header( 'submit.php' , 2 , _ALBM_FILEERROR ) ;
			exit ;
		}

		$xoopsDB->query( "INSERT INTO $table_text (lid, description) VALUES ($newid, '$desc_text')") or die( "DB error: INSERT text table" ) ;

		// Update User's Posts (Should be modified when need admission.)
		$xoopsDB->query( "UPDATE ".$xoopsDB->prefix('users')." SET posts = posts+$myalbum_addposts WHERE uid = $submitter" ) ;

		// Trigger Notification
		if( $status ) {
			$notification_handler =& xoops_gethandler( 'notification' ) ;

			// Global Notification
			$notification_handler->triggerEvent( 'global' , 0 , 'new_photo' , array( 'PHOTO_TITLE' => $title , 'PHOTO_URI' => "$mod_url/photo.php?lid=$newid&cid=$cid" ) ) ;

			// Category Notification
			$rs = $xoopsDB->query( "SELECT title FROM $table_cat WHERE cid=$cid" ) ;
			list( $cat_title ) = $xoopsDB->fetchRow( $rs ) ;
			$notification_handler->triggerEvent( 'category' , $cid , 'new_photo' , array( 'PHOTO_TITLE' => $title , 'CATEGORY_TITLE' => $cat_title , 'PHOTO_URI' => "$mod_url/photo.php?lid=$newid&cid=$cid" ) ) ;
		}

		redirect_header("index.php",2,_ALBM_RECEIVED."");
		exit ;

	} else {

		include(XOOPS_ROOT_PATH."/header.php");

		echo $uploader->getErrors();
		@unlink( $uploader->getSavedDestination() ) ;

		include( XOOPS_ROOT_PATH . "/footer.php" ) ;
		exit ;
	}

} else {

	include(XOOPS_ROOT_PATH."/header.php");
	OpenTable() ;
	myheader() ;

	include_once( "../../class/xoopsformloader.php" ) ;
	include_once( "../../include/xoopscodes.php" ) ;
	$form = new XoopsThemeForm(_ALBM_PHOTOUPLOAD, "uploadphoto", "submit.php");
	$pixels_text = "$myalbum_width x $myalbum_height" ;
	if( $myalbum_canresize ) $pixels_text .= " (auto resize)" ;
	$pixels_label = new XoopsFormLabel( _ALBM_MAXPIXEL , $pixels_text ) ;
	$size_label = new XoopsFormLabel( _ALBM_MAXSIZE , $myalbum_fsize ) ;
	$form->setExtra( "enctype='multipart/form-data'" ) ;

	$question_text = new XoopsFormText( _ALBM_PHOTOTITLE , "title" , 50 , 255 ) ;

	if( isset( $_GET['cid'] ) ) $cid = $_GET['cid'] ;
	else $cid = 0 ;

	$cat = new XoopsFormSelect( _ALBM_PHOTOCAT , "cid" , $cid ) ;
	$tree = $cattree->getChildTreeArray(0,"title") ;
	foreach( $tree as $leaf ) {
		$leaf['prefix'] = substr($leaf['prefix'], 0, -1);
		$leaf['prefix'] = str_replace(".","--",$leaf['prefix']);
		$cat->addOption( $leaf['cid'],$leaf['prefix'].$leaf['title'] ) ;
	}
	$desc_tarea = new XoopsFormDhtmlTextArea( _ALBM_PHOTODESC , "desc_text" , "" , 10 , 50 ) ;
	$file_form = new XoopsFormFile( _ALBM_SELECTFILE , "photofile", $myalbum_fsize ) ;
	$file_form->setExtra( "size='70'" ) ;

	if( $myalbum_canrotate ) {
		$rotate_radio = new XoopsFormRadio( _ALBM_RADIO_ROTATETITLE , 'rotate' , 'rot0' ) ;
		$rotate_radio->addOption( 'rot0' , _ALBM_RADIO_ROTATE0." &nbsp; " ) ;
		$rotate_radio->addOption( 'rot90' , "<img src='images/icon_rotate90.gif' alt='"._ALBM_RADIO_ROTATE90."' /> &nbsp; " ) ;
		$rotate_radio->addOption( 'rot180' , "<img src='images/icon_rotate180.gif' alt='"._ALBM_RADIO_ROTATE180."' /> &nbsp; " ) ;
		$rotate_radio->addOption( 'rot270' , "<img src='images/icon_rotate270.gif' alt='"._ALBM_RADIO_ROTATE270."' /> &nbsp; " ) ;
	}

	$op_hidden = new XoopsFormHidden( "op" , "submit" ) ;
	$counter_hidden = new XoopsFormHidden( "fieldCounter" , 1 ) ;
	$submit_button = new XoopsFormButton( "" , "submit" , _SUBMIT , "submit" ) ;
	$form->addElement( $pixels_label ) ;
	$form->addElement( $size_label ) ;
	$form->addElement( $question_text ) ;
	$form->addElement( $desc_tarea ) ;
	$form->addElement( $cat ) ;
	$form->addElement( $file_form ) ;
	if( $myalbum_canrotate ) $form->addElement( $rotate_radio ) ;
	$form->addElement( $counter_hidden ) ;
	$form->addElement( $op_hidden ) ;
	$form->addElement( $submit_button ) ;
	$form->setRequired( $file_form ) ;
	$form->display() ;
	CloseTable() ;
	myfooter() ;
}

include( XOOPS_ROOT_PATH . "/footer.php" ) ;

?>